SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
sf::Text Class Reference
Graphics module

Graphical text that can be drawn to a render target. More...

`#include <Text.hpp>`

Inheritance diagram for sf::Text:

## Public Types
enum | Style { Regular = 0, Bold = 1 << 0, Italic = 1 << 1, Underlined = 1 << 2 }
| Enumeration of the string drawing styles. More...

## Public Member Functions
| Text ()
| Default constructor. More...
| Text (const String &string, const Font &font, unsigned int characterSize=30)
| Construct the text from a string, font and size. More...
void | setString (const String &string)
| Set the text's string. More...
void | setFont (const Font &font)
| Set the text's font. More...
void | setCharacterSize (unsigned int size)
| Set the character size. More...
void | setStyle (Uint32 style)
| Set the text's style. More...
void | setColor (const Color &color)
| Set the global color of the text. More...
const String & | getString () const
| Get the text's string. More...
const Font * | getFont () const
| Get the text's font. More...
unsigned int | getCharacterSize () const
| Get the character size. More...
Uint32 | getStyle () const
| Get the text's style. More...
const Color & | getColor () const
| Get the global color of the text. More...
Vector2f | findCharacterPos (std::size_t index) const
| Return the position of the index-th character. More...
FloatRect | getLocalBounds () const
| Get the local bounding rectangle of the entity. More...
FloatRect | getGlobalBounds () const
| Get the global bounding rectangle of the entity. More...
void | setPosition (float x, float y)
| set the position of the object More...
void | setPosition (const Vector2f &position)
| set the position of the object More...
void | setRotation (float angle)
| set the orientation of the object More...
void | setScale (float factorX, float factorY)
| set the scale factors of the object More...
void | setScale (const Vector2f &factors)
| set the scale factors of the object More...
void | setOrigin (float x, float y)
| set the local origin of the object More...
void | setOrigin (const Vector2f &origin)
| set the local origin of the object More...
const Vector2f & | getPosition () const
| get the position of the object More...
float | getRotation () const
| get the orientation of the object More...
const Vector2f & | getScale () const
| get the current scale of the object More...
const Vector2f & | getOrigin () const
| get the local origin of the object More...
void | move (float offsetX, float offsetY)
| Move the object by a given offset. More...
void | move (const Vector2f &offset)
| Move the object by a given offset. More...
void | rotate (float angle)
| Rotate the object. More...
void | scale (float factorX, float factorY)
| Scale the object. More...
void | scale (const Vector2f &factor)
| Scale the object. More...
const Transform & | getTransform () const
| get the combined transform of the object More...
const Transform & | getInverseTransform () const
| get the inverse of the combined transform of the object More...

## Detailed Description

Graphical text that can be drawn to a render target.

sf::Text is a drawable class that allows to easily display some text with custom style and color on a render target.

It inherits all the functions from sf::Transformable: position, rotation, scale, origin. It also adds text-specific properties such as the font to use, the character size, the font style (bold, italic, underlined), the global color and the text to display of course. It also provides convenience functions to calculate the graphical size of the text, or to get the global position of a given character.

sf::Text works in combination with the sf::Font class, which loads and provides the glyphs (visual characters) of a given font.

The separation of sf::Font and sf::Text allows more flexibility and better performances: indeed a sf::Font is a heavy resource, and any operation on it is slow (often too slow for real-time applications). On the other side, a sf::Text is a lightweight object which can combine the glyphs data and metrics of a sf::Font to display any text on a render target.

It is important to note that the sf::Text instance doesn't copy the font that it uses, it only keeps a reference to it. Thus, a sf::Font must not be destructed while it is used by a sf::Text (i.e. never write a function that uses a local sf::Font instance for creating a text).

Usage example:

// Declare and load a font
sf::Font font;
font.loadFromFile("arial.ttf");
// Create a text
sf::Text text("hello", font);
text.setCharacterSize(30);
text.setStyle(sf::Text::Bold);
text.setColor(sf::Color::Red);
// Draw it
window.draw(text);

See Also
  sf::Font, sf::Transformable

Definition at line 48 of file Text.hpp.

## Member Enumeration Documentation

enum sf::Text::Style

Enumeration of the string drawing styles.

Enumerator
Regular | Regular characters, no style.
Bold | Bold characters.
Italic | Italic characters.
Underlined | Underlined characters.

Definition at line 56 of file Text.hpp.

## Constructor & Destructor Documentation

sf::Text::Text | ( | ) |  |

Default constructor.

Creates an empty text.

sf::Text::Text | ( | const String & | string,
|  | const Font & | font,
|  | unsigned int | characterSize = `30`
| ) |  |

Construct the text from a string, font and size.

Parameters

  string | Text assigned to the string
  font | Font used to draw the string
  characterSize | Base size of characters, in pixels

## Member Function Documentation

Vector2f sf::Text::findCharacterPos | ( | std::size_t | index) |  | const

Return the position of the index-th character.

This function computes the visual position of a character from its index in the string. The returned position is in global coordinates (translation, rotation, scale and origin are applied). If index is out of range, the position of the end of the string is returned.

Parameters

  index | Index of the character

Returns
  Position of the character

unsigned int sf::Text::getCharacterSize | ( | ) |  | const

Get the character size.

Returns
  Size of the characters, in pixels

See Also
  setCharacterSize

const Color& sf::Text::getColor | ( | ) |  | const

Get the global color of the text.

Returns
  Global color of the text

See Also
  setColor

const Font* sf::Text::getFont | ( | ) |  | const

Get the text's font.

If the text has no font attached, a NULL pointer is returned. The returned reference is const, which means that you cannot modify the font when you get it from this function.

Returns
  Pointer to the text's font

See Also
  setFont

FloatRect sf::Text::getGlobalBounds | ( | ) |  | const

Get the global bounding rectangle of the entity.

The returned rectangle is in global coordinates, which means that it takes in account the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the sprite in the global 2D world's coordinate system.

Returns
  Global bounding rectangle of the entity

const Transform& sf::Transformable::getInverseTransform | ( | ) |  | const
| inherited

get the inverse of the combined transform of the object

Returns
  Inverse of the combined transformations applied to the object

See Also
  getTransform

FloatRect sf::Text::getLocalBounds | ( | ) |  | const

Get the local bounding rectangle of the entity.

The returned rectangle is in local coordinates, which means that it ignores the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the entity in the entity's coordinate system.

Returns
  Local bounding rectangle of the entity

const Vector2f& sf::Transformable::getOrigin | ( | ) |  | const
| inherited

get the local origin of the object

Returns
  Current origin

See Also
  setOrigin

const Vector2f& sf::Transformable::getPosition | ( | ) |  | const
| inherited

get the position of the object

Returns
  Current position

See Also
  setPosition

float sf::Transformable::getRotation | ( | ) |  | const
| inherited

get the orientation of the object

The rotation is always in the range [0, 360].

Returns
  Current rotation, in degrees

See Also
  setRotation

const Vector2f& sf::Transformable::getScale | ( | ) |  | const
| inherited

get the current scale of the object

Returns
  Current scale factors

See Also
  setScale

const String& sf::Text::getString | ( | ) |  | const

Get the text's string.

The returned string is a sf::String, which can automatically be converted to standard string types. So, the following lines of code are all valid:

sf::String s1 = text.getString();
std::string s2 = text.getString();
std::wstring s3 = text.getString();

Returns
  Text's string

See Also
  setString

Uint32 sf::Text::getStyle | ( | ) |  | const

Get the text's style.

Returns
  Text's style

See Also
  setStyle

const Transform& sf::Transformable::getTransform | ( | ) |  | const
| inherited

get the combined transform of the object

Returns
  Transform combining the position/rotation/scale/origin of the object

See Also
  getInverseTransform

void sf::Transformable::move | ( | float | offsetX,
|  | float | offsetY
| ) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f pos = object.getPosition();
object.setPosition(pos.x + offsetX, pos.y + offsetY);

Parameters

  offsetX | X offset
  offsetY | Y offset

See Also
  setPosition

void sf::Transformable::move | ( | const Vector2f & | offset) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

object.setPosition(object.getPosition() + offset);

Parameters

  offset | Offset

See Also
  setPosition

void sf::Transformable::rotate | ( | float | angle) |  |
| inherited

Rotate the object.

This function adds to the current rotation of the object, unlike setRotation which overwrites it. Thus, it is equivalent to the following code:

object.setRotation(object.getRotation() + angle);

Parameters

  angle | Angle of rotation, in degrees

void sf::Transformable::scale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factorX, scale.y * factorY);

Parameters

  factorX | Horizontal scale factor
  factorY | Vertical scale factor

See Also
  setScale

void sf::Transformable::scale | ( | const Vector2f & | factor) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factor.x, scale.y * factor.y);

Parameters

  factor | Scale factors

See Also
  setScale

void sf::Text::setCharacterSize | ( | unsigned int | size) |  |

Set the character size.

The default size is 30.

Parameters

  size | New character size, in pixels

See Also
  getCharacterSize

void sf::Text::setColor | ( | const Color & | color) |  |

Set the global color of the text.

By default, the text's color is opaque white.

Parameters

  color | New color of the text

See Also
  getColor

void sf::Text::setFont | ( | const Font & | font) |  |

Set the text's font.

The font argument refers to a font that must exist as long as the text uses it. Indeed, the text doesn't store its own copy of the font, but rather keeps a pointer to the one that you passed to this function. If the font is destroyed and the text tries to use it, the behaviour is undefined.

Parameters

  font | New font

See Also
  getFont

void sf::Transformable::setOrigin | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new origin
  y | Y coordinate of the new origin

See Also
  getOrigin

void sf::Transformable::setOrigin | ( | const Vector2f & | origin) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  origin | New origin

See Also
  getOrigin

void sf::Transformable::setPosition | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new position
  y | Y coordinate of the new position

See Also
  move, getPosition

void sf::Transformable::setPosition | ( | const Vector2f & | position) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  position | New position

See Also
  move, getPosition

void sf::Transformable::setRotation | ( | float | angle) |  |
| inherited

set the orientation of the object

This function completely overwrites the previous rotation. See the rotate function to add an angle based on the previous rotation instead. The default rotation of a transformable object is 0.

Parameters

  angle | New rotation, in degrees

See Also
  rotate, getRotation

void sf::Transformable::setScale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factorX | New horizontal scale factor
  factorY | New vertical scale factor

See Also
  scale, getScale

void sf::Transformable::setScale | ( | const Vector2f & | factors) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factors | New scale factors

See Also
  scale, getScale

void sf::Text::setString | ( | const String & | string) |  |

Set the text's string.

The string argument is a sf::String, which can automatically be constructed from standard string types. So, the following calls are all valid:

text.setString("hello");
text.setString(L"hello");
text.setString(std::string("hello"));
text.setString(std::wstring(L"hello"));

A text's string is empty by default.

Parameters

  string | New string

See Also
  getString

void sf::Text::setStyle | ( | Uint32 | style) |  |

Set the text's style.

You can pass a combination of one or more styles, for example sf::Text::Bold | sf::Text::Italic. The default style is sf::Text::Regular.

Parameters

  style | New style

See Also
  getStyle

The documentation for this class was generated from the following file:

- Text.hpp